//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "GereClient.h"
#include "WSocket.hpp"
#define ChatPort "2200"
#include <stdlib.h>
#include <MPlayer.hpp>
class TGereClient : public TWSocket
{
private:
    void __fastcall DnsLookupDone(TObject *Sender, WORD Error);
    void __fastcall SessionConnected(TObject *Sender, WORD Error);
    void __fastcall SessionClosed(TObject *Sender, WORD Error);
    void __fastcall DataAvailable(TObject *Sender, WORD Error);
    TRichEdit *redMesgs;
    TButton *bouton;
    TTimer *tmrflash;
    TMediaPlayer *mplSon;
    char RcvBuf[1024];
    int  RcvLen;
public:
    virtual __fastcall TGereClient(TComponent *AOwner, TRichEdit *message, TButton *btn, TTimer *flash, TMediaPlayer *json, AnsiString cnom, int socket);
    virtual __fastcall ~TGereClient(void);
    void __fastcall Libere(void);
    int son;
    int flash;
    AnsiString nom;
};

typedef struct ELEM
        {
          TGereClient *client;
          ELEM *avant, *apres;
        } elem;

elem *chaine=NULL;

//---------------------------------------------------------------------------
#pragma package(smart_init)


//----------------------------------------------------------
// htol convertit une chaine reprsentant de l'hexa en long
long htol(char *cha)
{
long resultat;
int lgch,             // longueur de la chaine
    i,
    k,
    puissance;

  strupr(cha);      // tout le monde en majuscule

  lgch=strlen(cha);
  resultat=0;

  for(i=lgch-1;i>=0;i--)
  {
    puissance=1;
    for(k=i;k<lgch-1;k++)
      puissance*=16;

    if ((cha[i]>='A') && (cha[i]<='Z'))
      resultat+=puissance*(cha[i]-'A'+10);
    else
      if ((cha[i]>='0') && (cha[i]<='9'))
        resultat+=puissance*(cha[i]-'0');
      else
        return 0;
  }
  return resultat;
}

//---------------------------------------------------------------------------
// This event handler is triggered when the DNS lookup process is finished
// successfully or not. If DNS lookud failed, display a message.
// If DNS lookup successfull, ask TWSocket to connect the server.
void __fastcall TGereClient::DnsLookupDone(TObject *Sender,
    WORD Error)
{
    if (Error != 0) {
        // DNS Lookup has failed
        redMesgs->Lines->Add("Nom de serveur inconnu");
//        ConnectButton->Caption = "&Connecter";
        return;
    }

    // DNS lookup successfull. Try to see if we are the server and we are
    // trying to connect to ourself. Check loopback address, should also
    // check the local IP address (returned by LocalIPList)...
//    if ((SrvWSocket->State == wsListening) &&
//        (CliWSocket->DnsResult == "127.0.0.1")) {
//        redMesgs->Lines->Add("Vous essayez de vous connecter  vous-mme !!!!");
//        ConnectButton->Caption = "&Connecter";
//        return;
//    }

    // Transfert the IP address from DNSLookup to the TWSocket for connection
    // We could use the hostname for the Addr property, TWSocket will do the
    // DNS lookup for us, but it will block, maybe for a long time if DNS if
    // down.
    Addr  = DnsResult;
    Port  = ChatPort;
    Proto = "tcp";

    // The connect method is asynchronous. You get the control back quickly
    // The OnSessionConnected event will be eventually generated when the
    // connection is established.
    Connect();
}
//---------------------------------------------------------------------------
// This event handler is triggered when the connection is established with
// the server. Enable the send button and the message edit box.
void __fastcall TGereClient::SessionConnected(TObject *Sender,
    WORD Error)
{
    if (Error == WSAECONNREFUSED)
        redMesgs->Lines->Add("Aucun serveur disponible");
    else if (Error != 0)
        redMesgs->Lines->Add("Impossible de se connecter, erreur #" + IntToStr(Error));
    else {
        redMesgs->Lines->Add("Connect au serveur");

//        SendButton->Enabled  = TRUE;
//        MessageEdit->Enabled = TRUE;
    }
}
//---------------------------------------------------------------------------
// This event is triggered when the client connection is closed, either
// by the client himself or by the local user pushing the disconnect button
void __fastcall TGereClient::SessionClosed(TObject *Sender,
    WORD Error)
{
  if (chaine->apres ==NULL)
  {
      bouton->Caption = "&Connecter";
      bouton->Enabled = true;
  }

  Libere();
  delete this;
}

//---------------------------------------------------------------------------
// This event is triggered when data has been received from the client.
// A little bit of work here because the data can comes fragmented or in big
// chunks with several client lines. So we assemble the data received in a
// buffer and check the buffer for complete lines (there can be no complete
// line, exactly one complete line, several complete lines and may be an
// incomplete line at the end.
void __fastcall TGereClient::DataAvailable(TObject *Sender,
    WORD Error)
{
    int  Len;
    int  I;
    AnsiString Nom, Mesg, Recu;
    char Couleur[9];
    elem *actuel;

    // Receive the data that has arrived, put it after the data already here
    Len = Receive(&RcvBuf[RcvLen], sizeof(RcvBuf) - RcvLen - 1);
    if (Len <= 0)
        return;
    // Update our counter
    RcvLen = RcvLen + Len;
    // Place a null byte at the end of the buffer
    RcvBuf[RcvLen] = 0;

    // Scan the buffer to process each complete line
    while (TRUE) {
        // find the terminating line feed
        I = strchr(RcvBuf, 10) - RcvBuf;
        if (I < 0)
            break; // not found, incomplete line, break loop
        // Replace the line feed by a nul char, truncating the line
        RcvBuf[I] = 0;
        // Display the truncated line
        Recu=StrPas(RcvBuf);
        actuel=chaine;
        while (actuel!=NULL)
        {
          if (actuel->client!=this)
            actuel->client->SendStr(Recu+"\n");
          actuel=actuel->apres;
        }

        strncpy(Couleur, RcvBuf, 8);
        Couleur[8]=0;
        Nom=Recu.SubString(9,Recu.Pos(">")-8);
        Mesg=Recu.SubString(Recu.Pos(">")+1, Recu.Length()-Recu.Pos(">"));
        if (Nom=="System>")
          redMesgs->SelAttributes->Style = redMesgs->SelAttributes->Style << fsItalic;
        else
        {
          redMesgs->SelAttributes->Style = redMesgs->SelAttributes->Style >> fsItalic;
          if (Mesg.Pos(nom)!=0)
            redMesgs->SelAttributes->Style = redMesgs->SelAttributes->Style << fsBold;
          else
            redMesgs->SelAttributes->Style = redMesgs->SelAttributes->Style >> fsBold;
        }
        redMesgs->SelAttributes->Color=(TColor)htol(Couleur);
        redMesgs->SelText=Nom;
        redMesgs->SelAttributes->Color=clBlack;
        redMesgs->SelText=Mesg+"\r\n";
        redMesgs->SelAttributes->Style = redMesgs->SelAttributes->Style >> fsBold;
        redMesgs->SelAttributes->Style = redMesgs->SelAttributes->Style >> fsItalic;

        if (son)
        {
          if (mplSon->FileName != "")
            mplSon->Play();
          else
            Beep();
        }

        if (flash)
        {
          tmrflash->Enabled=false;
          tmrflash->Enabled=true;
        }

        // Restore the line feed }
        RcvBuf[I] = 10;
        // Was it the last line in the buffer ?
        if (I >= (RcvLen - 1)) {
            RcvLen = 0;
            break;
        }
        // Not the last line, move the next one in front of buffer
        memmove(RcvBuf, &RcvBuf[I + 1], RcvLen - I);
        RcvLen = RcvLen - I;
    }
}

_fastcall TGereClient::TGereClient(TComponent *AOwner, TRichEdit *message, TButton *btn, TTimer *flash, TMediaPlayer *json, AnsiString cnom, int socket): TWSocket(AOwner)
{
elem *nouveau;

  redMesgs=message;
  OnDnsLookupDone=DnsLookupDone;
  OnSessionConnected=SessionConnected;
  OnSessionClosed=SessionClosed;
  OnDataAvailable=DataAvailable;

  nouveau=(elem *)malloc(sizeof(elem));
  nouveau->client = this; //new TGereClient(TWSChatForm, redMesgs);
  nouveau->client->HSocket = socket;
  nouveau->apres=chaine;
  nouveau->avant=NULL;
  if (chaine!=NULL)
    chaine->avant=nouveau;
  chaine=nouveau;

  bouton=btn;
  tmrflash=flash;
  mplSon=json;
  nom=cnom;
}

_fastcall TGereClient::~TGereClient(void)
{
}

void FermeTout(void)
{
elem *actuel;

  actuel=chaine;
  while (actuel!=NULL)
  {
    actuel->client->SendStr("Termine\n");
    actuel=actuel->apres;
  }
}

void __fastcall TGereClient::Libere(void)
{
elem *actuel;

  actuel=chaine;
  while ((actuel!=NULL) && (actuel->client!=this))
    actuel=actuel->apres;

  if (actuel!=NULL)
  {
    if (actuel->avant!=NULL)
      (actuel->avant)->apres=actuel->apres;
    else
      chaine=actuel->apres;

    if (actuel->apres!=NULL)
      (actuel->apres)->avant=actuel->avant;

    free(actuel);
  }

}
