/*---------------------------------------------------------------------------

Author:       Franois PIETTE
Description:  TWSChat shows how to use TWSocket to build a chat program
Creation:     November 26, 1997
Version:      1.03
EMail:        francois.piette@pophost.eunet.be  francois.piette@rtfm.be
WebSite:      http://www.rtfm.be/fpiette/indexuk.htm
Support:      Use the mailing list twsocket@rtfm.be See website for details.
Legal issues: Copyright (C) 1997, 1998, 1999 by Franois PIETTE
              <francois.piette@pophost.eunet.be>

              This software is provided 'as-is', without any express or
              implied warranty.  In no event will the author be held liable
              for any  damages arising from the use of this software.

              Permission is granted to anyone to use this software for any
              purpose, including commercial applications, and to alter it
              and redistribute it freely, subject to the following
              restrictions:

              1. The origin of this software must not be misrepresented,
                 you must not claim that you wrote the original software.
                 If you use this software in a product, an acknowledgment
                 in the product documentation would be appreciated but is
                 not required.

              2. Altered source versions must be plainly marked as such, and
                 must not be misrepresented as being the original software.

              3. This notice may not be removed or altered from any source
                 distribution.

Updates:
Jan 10, 1998  V1.02 Corrected CliWSocketDataAvailable
Apr 12, 1998  V1.03 Adapted for BCB3

  ---------------------------------------------------------------------------*/
#if __BORLANDC__ == 0x520     // BCB1 is BC5.20   BCB3 is BC5.30
    #define _WINSOCKAPI_      // Prevent winsock.h from being included
#endif
#include <vcl\vcl.h>
#pragma hdrstop

#define ChatPort "2200"
#define TWSChatVersion 102
#define MaxFlash 10

#include "winchat1.h"
#include "options.h"
#include "stdlib.h"
#include "string.h"
#include "stdio.h"
#include "gereclient.cpp"
//---------------------------------------------------------------------------
#pragma link "WSocket"
#pragma resource "*.dfm"
TTWSChatForm *TWSChatForm;

int maxline, compte=MaxFlash;
AnsiString nomavant="";

//----------------------------------------------------------
// htol convertit une chaine reprsentant de l'hexa en long
/*long htol(char *chaine)
{
long resultat;
int lgch,             // longueur de la chaine
    i,
    k,
    puissance;

  strupr(chaine);      // tout le monde en majuscule

  lgch=strlen(chaine);
  resultat=0;

  for(i=lgch-1;i>=0;i--)
  {
    puissance=1;
    for(k=i;k<lgch-1;k++)
      puissance*=16;

    if ((chaine[i]>='A') && (chaine[i]<='Z'))
      resultat+=puissance*(chaine[i]-'A'+10);
    else
      if ((chaine[i]>='0') && (chaine[i]<='9'))
        resultat+=puissance*(chaine[i]-'0');
      else
        return 0;
  }
  return resultat;
} */

//---------------------------------------------------------------------------
__fastcall TTWSChatForm::TTWSChatForm(TComponent* Owner)
    : TForm(Owner)
{
}

//---------------------------------------------------------------------------
void __fastcall TTWSChatForm::StartServer()
{
    // Try to be a server
    SrvWSocket->Port  = ChatPort;
    SrvWSocket->Proto = "tcp";
    SrvWSocket->Addr  = "0.0.0.0";
    try {
        SrvWSocket->Listen();
        RunningRadioButton->Checked = TRUE;
        StoppedRadioButton->Checked = FALSE;
    } catch (const ESocketException &E) {
            // The socket is probably already in use
            RunningRadioButton->Checked = FALSE;
            StoppedRadioButton->Checked = TRUE;
            if (strncmp(E.Message.c_str(), "Error 10048", 11) == 0)
                redMesgs->Lines->Add("WinChat tourne dj en tant que serveur");
            else
                throw;
    }
}
//---------------------------------------------------------------------------
void __fastcall TTWSChatForm::FormShow(TObject *Sender)
{
FILE *fic;
char couleur[13], nom[23], serveur[53], ficson[512];

    if (!Initialized) {
        Initialized = TRUE;
        fic=fopen((ExtractFilePath(Application->ExeName)+"wchat.cfg").c_str(), "rt");
        if (fic!=NULL)
        {
          fgets(couleur, 10, fic);
          fgets(nom, 20, fic);
          fgets(serveur, 50, fic);
          fgets(ficson, 512, fic);
          couleur[strlen(couleur)-1]=0;
          nom[strlen(nom)-1]=0;
          serveur[strlen(serveur)-1]=0;
          ficson[strlen(ficson)-1]=0;

          edtNom->Text=nom;
          ServerEdit->Text=serveur;
          edtNom->Font->Color=(TColor)htol(couleur);
          cdlCouleur->Color=(TColor)htol(couleur);
          if (FileExists(StrPas(ficson)))
          {
            mplSon->FileName = StrPas(ficson);
            mplSon->Open();
          }
          else
            mplSon->FileName = "";

          fclose(fic);
        }
        StartServer();
        nomavant=edtNom->Text;
    }
}
//---------------------------------------------------------------------------
// The user has clicked on the 'connect' Button-> We will not connect here,
// but start the DNSLookup. We will receive a event when it is complete.
// The connection will be made at that later time.
void __fastcall TTWSChatForm::ConnectButtonClick(TObject *Sender)
{
  if (ConnectButton->Caption=="&Connecter")
  {
    ConnectButton->Caption = "&Dconnecter";
    CliWSocket->DnsLookup(ServerEdit->Text);
  }
  else
  {
    if (CliWSocket->State == wsConnected)
    {
      CliWSocket->SendStr("00000000System> "+edtNom->Text+" est parti(e)\n");
      CliWSocket->Close();
    }
    FermeTout();
  }
}
//---------------------------------------------------------------------------
// This event handler is triggered when the DNS lookup process is finished
// successfully or not. If DNS lookud failed, display a message.
// If DNS lookup successfull, ask TWSocket to connect the server.
void __fastcall TTWSChatForm::CliWSocketDnsLookupDone(TObject *Sender,
    WORD Error)
{
    if (Error != 0) {
        // DNS Lookup has failed
        redMesgs->Lines->Add("Nom de serveur inconnu");
        ConnectButton->Caption = "&Connecter";
        return;
    }

    // DNS lookup successfull. Try to see if we are the server and we are
    // trying to connect to ourself. Check loopback address, should also
    // check the local IP address (returned by LocalIPList)...
    if ((SrvWSocket->State == wsListening) &&
        (CliWSocket->DnsResult == "127.0.0.1")) {
        redMesgs->Lines->Add("Vous essayez de vous connecter  vous-mme !!!!");
        ConnectButton->Caption = "&Connecter";
        return;
    }

    // Transfert the IP address from DNSLookup to the TWSocket for connection
    // We could use the hostname for the Addr property, TWSocket will do the
    // DNS lookup for us, but it will block, maybe for a long time if DNS if
    // down.
    CliWSocket->Addr  = CliWSocket->DnsResult;
    CliWSocket->Port  = ChatPort;
    CliWSocket->Proto = "tcp";

    // The connect method is asynchronous. You get the control back quickly
    // The OnSessionConnected event will be eventually generated when the
    // connection is established.
    CliWSocket->Connect();
}
//---------------------------------------------------------------------------
// This event handler is triggered when the connection is established with
// the server. Enable the send button and the message edit box.
void __fastcall TTWSChatForm::CliWSocketSessionConnected(TObject *Sender,
    WORD Error)
{
    if (Error == WSAECONNREFUSED)
        redMesgs->Lines->Add("Aucun serveur disponible");
    else if (Error != 0)
        redMesgs->Lines->Add("Impossible de se connecter, erreur #" + IntToStr(Error));
    else {
        redMesgs->Lines->Add("Connect au serveur");
        CliWSocket->SendStr("00000000System> "+edtNom->Text+" viens de se connecter\n");
        SendButton->Enabled  = TRUE;
        MessageEdit->Enabled = TRUE;
    }
}
//---------------------------------------------------------------------------
// This event is triggered when the client connection is closed, either
// by the client himself or by the local user pushing the disconnect button
void __fastcall TTWSChatForm::CliWSocketSessionClosed(TObject *Sender,
    WORD Error)
{
    ConnectButton->Caption = "&Connecter";
    if (SendButton->Enabled) {
        SendButton->Enabled   = FALSE;
        MessageEdit->Enabled  = FALSE;
        redMesgs->Lines->Add("Dconnect");
    }
}

//---------------------------------------------------------------------------
// This event is triggered when data has been received from the client.
// A little bit of work here because the data can comes fragmented or in big
// chunks with several client lines. So we assemble the data received in a
// buffer and check the buffer for complete lines (there can be no complete
// line, exactly one complete line, several complete lines and may be an
// incomplete line at the end.
void __fastcall TTWSChatForm::CliWSocketDataAvailable(TObject *Sender,
    WORD Error)
{
    int  Len;
    int  I;
    AnsiString Nom, Mesg, Recu;
    char Couleur[9];

    // Receive the data that has arrived, put it after the data already here
    Len = CliWSocket->Receive(&RcvBuf[RcvLen], sizeof(RcvBuf) - RcvLen - 1);
    if (Len <= 0)
        return;
    // Update our counter
    RcvLen = RcvLen + Len;
    // Place a null byte at the end of the buffer
    RcvBuf[RcvLen] = 0;

    // Scan the buffer to process each complete line
    while (TRUE) {
        // find the terminating line feed
        I = strchr(RcvBuf, 10) - RcvBuf;
        if (I < 0)
            break; // not found, incomplete line, break loop
        // Replace the line feed by a nul char, truncating the line
        RcvBuf[I] = 0;
        // Display the truncated line
        Recu=StrPas(RcvBuf);

        if (Recu != "Termine")
        {
          strncpy(Couleur, RcvBuf, 8);
          Couleur[8]=0;
          Nom=Recu.SubString(9,Recu.Pos(">")-8);
          Mesg=Recu.SubString(Recu.Pos(">")+1, Recu.Length()-Recu.Pos(">"));
          if (Nom=="System>")
            redMesgs->SelAttributes->Style = redMesgs->SelAttributes->Style << fsItalic;
          else
          {
            redMesgs->SelAttributes->Style = redMesgs->SelAttributes->Style >> fsItalic;
            if (Mesg.Pos(edtNom->Text)!=0)
              redMesgs->SelAttributes->Style = redMesgs->SelAttributes->Style << fsBold;
            else
              redMesgs->SelAttributes->Style = redMesgs->SelAttributes->Style >> fsBold;
          }
          redMesgs->SelAttributes->Color=(TColor)htol(Couleur);
          redMesgs->SelText=Nom;
          redMesgs->SelAttributes->Color=clBlack;
          redMesgs->SelText=Mesg+"\r\n";
          redMesgs->SelAttributes->Style = redMesgs->SelAttributes->Style >> fsItalic;
          redMesgs->SelAttributes->Style = redMesgs->SelAttributes->Style >> fsBold;
        }
        else
        {
          redMesgs->SelText="Le serveur a coup\r\n";
          CliWSocket->Close();
        }

        if (mnuSon->Checked == true)
        {
          if (mplSon->FileName != "")
            mplSon->Play();
          else
            Beep();
        }

        if (mnuFlash->Checked == true)
        {
          tmrFlash->Enabled = false;
          tmrFlash->Enabled = true;
        }
        // Restore the line feed }
        RcvBuf[I] = 10;
        // Was it the last line in the buffer ?
        if (I >= (RcvLen - 1)) {
            RcvLen = 0;
            break;
        }
        // Not the last line, move the next one in front of buffer
        memmove(RcvBuf, &RcvBuf[I + 1], RcvLen - I);
        RcvLen = RcvLen - I;
    }
}
//---------------------------------------------------------------------------
// This event is triggered when we - as a server - have received a client
// connection request. We must accept the connection. Two cases: we are
// already busy with another client, or this is the first client connecting.
void __fastcall TTWSChatForm::SrvWSocketSessionAvailable(TObject *Sender,
    WORD Error)
{
TGereClient *temp;

    temp = new TGereClient(TWSChatForm, redMesgs, ConnectButton, tmrFlash, mplSon, edtNom->Text, SrvWSocket->Accept());
    temp->son = mnuSon->Checked;
    temp->flash = mnuFlash->Checked;
    ConnectButton->Caption = "&Dconnecter";
    SendButton->Enabled    = TRUE;
    MessageEdit->Enabled   = TRUE;

    redMesgs->Lines->Add("Connect  " + temp->GetPeerAddr());
}

//---------------------------------------------------------------------------
// The user has clicked on the send Button-> Just send the data in the edit
// box and a CRLF pair to make a complete line.
void __fastcall TTWSChatForm::SendButtonClick(TObject *Sender)
{
char cha[34], temp[34];
unsigned int i;
elem *actuel;

    ltoa(cdlCouleur->Color, cha, 16);
    temp[0]=0;
    for(i=0;i<8-strlen(cha);i++)
      strcat(temp, "0");
    strcat(temp, cha);
    strcpy(cha, temp);

    actuel=chaine;
    while (actuel!=NULL)
    {
      actuel->client->SendStr(cha+edtNom->Text+"> "+MessageEdit->Text + "\r\n");
      actuel=actuel->apres;
    }
    if (CliWSocket->State==wsConnected)
      CliWSocket->SendStr(cha+edtNom->Text+"> "+MessageEdit->Text + "\r\n");

    redMesgs->SelAttributes->Color=cdlCouleur->Color;
    redMesgs->SelText=edtNom->Text+"> ";
    redMesgs->SelAttributes->Color=clBlack;
    redMesgs->SelText=MessageEdit->Text+"\r\n";
    MessageEdit->Text="";
}
//---------------------------------------------------------------------------
void __fastcall TTWSChatForm::StoppedRadioButtonClick(TObject *Sender)
{
    SrvWSocket->Close();
    RunningRadioButton->Checked = FALSE;
    StoppedRadioButton->Checked = TRUE;
}
//---------------------------------------------------------------------------
void __fastcall TTWSChatForm::RunningRadioButtonClick(TObject *Sender)
{
    if (SrvWSocket->State != wsListening)
        StartServer();
}
//---------------------------------------------------------------------------



void __fastcall TTWSChatForm::btnCouleurClick(TObject *Sender)
{
  cdlCouleur->Execute();
  edtNom->Font->Color=cdlCouleur->Color;
}
//---------------------------------------------------------------------------

void __fastcall TTWSChatForm::redMesgsResizeRequest(TObject *Sender,
      TRect &Rect)
{
int lgnact, lgnvis;


  lgnact=SendMessage(redMesgs->Handle, EM_LINEFROMCHAR, -1, 0);
  if (maxline==0)
    if (Rect.Bottom>redMesgs->Top+redMesgs->Height)
      maxline=lgnact;

  if (lgnact>maxline)
  {
    lgnvis=SendMessage(redMesgs->Handle, EM_GETFIRSTVISIBLELINE, 0, 0);
    SendMessage(redMesgs->Handle, EM_LINESCROLL, 0, (lgnact-maxline)-lgnvis);
  }
}
//---------------------------------------------------------------------------

void __fastcall TTWSChatForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
FILE *fic;
char couleur[13], nom[23], serveur[53], temp[9], *ficson;
unsigned int i;

  FermeTout();
  if (CliWSocket->State==wsConnected)
  {
    CliWSocket->SendStr("00000000System> "+edtNom->Text+" est parti(e)\n");
    CliWSocket->Close();
  }

  fic=fopen((ExtractFilePath(Application->ExeName)+"wchat.cfg").c_str(), "wt");
  if (fic!=NULL)
  {
    ltoa(cdlCouleur->Color, couleur, 16);
    temp[0]=0;
    for(i=0;i<8-strlen(couleur);i++)
      strcat(temp, "0");
    strcat(temp, couleur);
    strcpy(couleur, temp);
    strcpy(nom, (edtNom->Text).c_str());
    strcpy(serveur, (ServerEdit->Text).c_str());
    ficson=(char *)malloc((mplSon->FileName.Length()+3)*sizeof(char));
    StrPCopy(ficson, mplSon->FileName);

    strcat(couleur, "\r\n");
    strcat(nom, "\r\n");
    strcat(serveur, "\r\n");
    strcat(ficson, "\r\n");

    fputs(couleur, fic);
    fputs(nom, fic);
    fputs(serveur, fic);
    fputs(ficson, fic);
    fclose(fic);
    free(ficson);
  }
}
//---------------------------------------------------------------------------


void __fastcall TTWSChatForm::edtNomDblClick(TObject *Sender)
{
  cdlCouleur->Execute();
  edtNom->Font->Color=cdlCouleur->Color;
}
//---------------------------------------------------------------------------

void __fastcall TTWSChatForm::Changerdecouleur1Click(TObject *Sender)
{
  cdlCouleur->Execute();
  edtNom->Font->Color=cdlCouleur->Color;
}
//---------------------------------------------------------------------------

void __fastcall TTWSChatForm::mnuChgtNomClick(TObject *Sender)
{
  mnuChgtNom->Checked = (mnuChgtNom->Checked == true) ? false : true;
}
//---------------------------------------------------------------------------

void __fastcall TTWSChatForm::mnuSonClick(TObject *Sender)
{
elem *actuel;
  mnuSon->Checked = (mnuSon->Checked == true) ? false : true;
  actuel=chaine;
  while (actuel!=NULL)
  {
    actuel->client->son = mnuFlash->Checked;
    actuel=actuel->apres;
  }
}
//---------------------------------------------------------------------------

void __fastcall TTWSChatForm::mnuQuitterClick(TObject *Sender)
{
  Application->Terminate();
}
//---------------------------------------------------------------------------


void __fastcall TTWSChatForm::tmrFlashTimer(TObject *Sender)
{
  FlashWindow(Application->Handle, 1);
  FlashWindow(TWSChatForm->Handle, 1);

  if (compte==0)
  {
    FlashWindow(Application->Handle, 0);
    FlashWindow(TWSChatForm->Handle, 0);
    tmrFlash->Enabled=false;
    compte=MaxFlash;
  }
  compte--;
}
//---------------------------------------------------------------------------

void __fastcall TTWSChatForm::mnuFlashClick(TObject *Sender)
{
elem *actuel;
  mnuFlash->Checked = (mnuFlash->Checked == true) ? false : true;

  actuel=chaine;
  while (actuel!=NULL)
  {
    actuel->client->flash = mnuFlash->Checked;
    actuel=actuel->apres;
  }
}
//---------------------------------------------------------------------------



void __fastcall TTWSChatForm::edtNomExit(TObject *Sender)
{
elem *actuel;

  if ((mnuChgtNom->Checked == true) && (edtNom->Text != nomavant))
  {
    if (CliWSocket->State == wsConnected)
      CliWSocket->SendStr("00000000System> " + nomavant + " a chang son pseudo en : "+ edtNom->Text+"\n");

    actuel=chaine;
    while(actuel!=NULL)
    {
      actuel->client->SendStr("00000000System> " + nomavant + " a chang son pseudo en : "+ edtNom->Text+"\n");
      actuel->client->nom = edtNom->Text;
      actuel=actuel->apres;
    }
    
    nomavant=edtNom->Text;
  }
}
//---------------------------------------------------------------------------


void __fastcall TTWSChatForm::mnuFicSonClick(TObject *Sender)
{
elem *actuel;
  if (frmOptions->ShowModal()==mrOk)
  {
    if (frmOptions->rbtFichier->Checked==true)
    {
      mplSon->FileName=frmOptions->edtFichier->Text;
      mplSon->Open();
    }
    else
      mplSon->FileName="";

    actuel=chaine;
    while (actuel!=NULL)
    {
      actuel->client->son = frmOptions->ckbSon->Checked;
      actuel=actuel->apres;
    }
    mnuSon->Checked=frmOptions->ckbSon->Checked;
  }
}
//---------------------------------------------------------------------------

void __fastcall TTWSChatForm::FormResize(TObject *Sender)
{
  SendButton->Left=Panel2->Width-68;
  MessageEdit->Width=SendButton->Left-15;
}
//---------------------------------------------------------------------------



